]> git.proxmox.com Git - mirror_lxc.git/blob - templates/lxc-altlinux.in
Updated template for ALTLinux.
[mirror_lxc.git] / templates / lxc-altlinux.in
1 #!/bin/bash
2
3 #
4 # template script for generating altlinux container for LXC
5 #
6
7 #
8 # lxc: linux Container library
9
10 # Authors:
11 # Alexey Shabalin <shaba@altlinux.org>
12
13 # This library is free software; you can redistribute it and/or
14 # modify it under the terms of the GNU Lesser General Public
15 # License as published by the Free Software Foundation; either
16 # version 2.1 of the License, or (at your option) any later version.
17
18 # This library is distributed in the hope that it will be useful,
19 # but WITHOUT ANY WARRANTY; without even the implied warranty of
20 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
21 # Lesser General Public License for more details.
22
23 # You should have received a copy of the GNU Lesser General Public
24 # License along with this library; if not, write to the Free Software
25 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
26
27 # Detect use under userns (unsupported)
28 for arg in "$@"; do
29 [ "$arg" = "--" ] && break
30 if [ "$arg" = "--mapped-uid" -o "$arg" = "--mapped-gid" ]; then
31 echo "This template can't be used for unprivileged containers." 1>&2
32 echo "You may want to try the \"download\" template instead." 1>&2
33 exit 1
34 fi
35 done
36
37 # Make sure the usual locations are in PATH
38 export PATH=$PATH:/usr/sbin:/usr/bin:/sbin:/bin
39
40 #Configurations
41 arch=$(uname -m)
42 cache_base=@LOCALSTATEDIR@/cache/lxc/altlinux/$arch
43 default_path=@LXCPATH@
44 default_profile=default
45 profile_dir=/etc/lxc/profiles
46 root_password=rooter
47 lxc_network_type=veth
48 lxc_network_link=virbr0
49
50 # is this altlinux?
51 [ -f /etc/altlinux-release ] && is_altlinux=true
52
53 configure_altlinux()
54 {
55
56 # disable selinux in altlinux
57 mkdir -p $rootfs_path/selinux
58 echo 0 > $rootfs_path/selinux/enforce
59
60 mkdir -p ${rootfs_path}/etc/net/ifaces/veth0
61 cat <<EOF > ${rootfs_path}/etc/net/ifaces/veth0/options
62 BOOTPROTO=${BOOTPROTO}
63 ONBOOT=yes
64 NM_CONTROLLED=no
65 TYPE=eth
66 EOF
67
68 if [ ${BOOTPROTO} != "dhcp" ]; then
69 # ip address
70 cat <<EOF > ${rootfs_path}/etc/net/ifaces/veth0/ipv4address
71 ${ipv4}
72 EOF
73
74 cat <<EOF > ${rootfs_path}/etc/net/ifaces/veth0/ipv4route
75 ${gw}
76 EOF
77
78 cat <<EOF > ${rootfs_path}/etc/net/ifaces/veth0/resolv.conf
79 nameserver ${dns}
80 EOF
81
82 cat <<EOF > ${rootfs_path}/etc/net/ifaces/veth0/ipv6address
83 ${ipv6}
84 EOF
85
86 cat <<EOF > ${rootfs_path}/etc/net/ifaces/veth0/ipv6route
87 ${gw6}
88 EOF
89
90 fi
91
92 # set the hostname
93 cat <<EOF > ${rootfs_path}/etc/sysconfig/network
94 NETWORKING=yes
95 CONFMETHOD=etcnet
96 HOSTNAME=${UTSNAME}
97 RESOLV_MODS=yes
98 EOF
99
100 # set minimal hosts
101 cat <<EOF > $rootfs_path/etc/hosts
102 127.0.0.1 localhost.localdomain localhost $name
103 EOF
104 # Allow to login at virsh console. loginuid.so doen't work in the absence of auditd.
105 # sed -i 's/^.*loginuid.so.*$/\#&/' ${rootfs_path}/etc/pam.d/common-login
106
107 # Allow root to login at virsh console
108 echo "pts/0" >> ${rootfs_path}/etc/securetty
109 echo "console" >> ${rootfs_path}/etc/securetty
110
111 chroot ${rootfs_path} chkconfig network on
112 chroot ${rootfs_path} chkconfig syslogd on
113 chroot ${rootfs_path} chkconfig random on
114 chroot ${rootfs_path} chkconfig rawdevices off
115 chroot ${rootfs_path} chkconfig fbsetfont off
116 # chroot ${rootfs_path} chkconfig keytable off
117
118 subst 's/^\([3-9]\+:[0-9]\+:respawn:\/sbin\/mingetty.*\)/#\1/' ${rootfs_path}/etc/inittab
119 echo "c1:2345:respawn:/sbin/mingetty --noclear console" >> ${rootfs_path}/etc/inittab
120 subst 's,\/dev\/tty12,/var/log/syslog/console,' ${rootfs_path}/etc/syslog.conf
121
122 dev_path="${rootfs_path}/dev"
123 rm -rf ${dev_path}
124 mkdir -p ${dev_path}
125 mknod -m 666 ${dev_path}/null c 1 3
126 mknod -m 666 ${dev_path}/zero c 1 5
127 mknod -m 644 ${dev_path}/random c 1 8
128 mknod -m 644 ${dev_path}/urandom c 1 9
129 mkdir -m 755 ${dev_path}/pts
130 mkdir -m 1777 ${dev_path}/shm
131 mknod -m 666 ${dev_path}/tty c 5 0
132 chown root:tty ${dev_path}/tty
133 mknod -m 600 ${dev_path}/tty0 c 4 0
134 mknod -m 600 ${dev_path}/tty1 c 4 1
135 mknod -m 600 ${dev_path}/tty2 c 4 2
136 mknod -m 600 ${dev_path}/tty3 c 4 3
137 mknod -m 600 ${dev_path}/tty4 c 4 4
138 mknod -m 600 ${dev_path}/console c 5 1
139 mknod -m 666 ${dev_path}/full c 1 7
140 mknod -m 600 ${dev_path}/initctl p
141 mknod -m 666 ${dev_path}/ptmx c 5 2
142 chown root:tty ${dev_path}/ptmx
143 ln -s /proc/self/fd ${dev_path}/fd
144 ln -s /proc/kcore ${dev_path}/core
145 mkdir -m 755 ${dev_path}/mapper
146 mknod -m 600 ${dev_path}/mapper/control c 10 236
147 mkdir -m 755 ${dev_path}/net
148 mknod -m 666 ${dev_path}/net/tun c 10 200
149
150 echo "setting root passwd to $root_password"
151 echo "root:$root_password" | chroot $rootfs_path chpasswd
152
153 return 0
154 }
155
156 download_altlinux()
157 {
158
159 # check the mini altlinux was not already downloaded
160 INSTALL_ROOT=$cache/partial
161 mkdir -p $INSTALL_ROOT
162 if [ $? -ne 0 ]; then
163 echo "Failed to create '$INSTALL_ROOT' directory"
164 return 1
165 fi
166
167 # download a mini altlinux into a cache
168 echo "Downloading altlinux minimal ..."
169 APT_GET="apt-get -o RPM::RootDir=$INSTALL_ROOT -y"
170 PKG_LIST="$(grep -hs '^[^#]' "$profile_dir/$profile")"
171 # if no configuration file $profile -- fall back to default list of packages
172 [ -z "$PKG_LIST" ] && PKG_LIST="interactivesystem apt apt-conf-sisyphus etcnet openssh-server systemd systemd-units systemd-sysvinit"
173
174 mkdir -p $INSTALL_ROOT/var/lib/rpm
175 rpm --root $INSTALL_ROOT --initdb
176
177 # some scripts want to have /dev/null at least
178 dev_path="$INSTALL_ROOT/dev"
179 if [ ! -c "${dev_path}/null" ]; then
180 mkdir -p "${dev_path}"
181 mknod -m 666 "${dev_path}/null" c 1 3
182 fi
183
184 $APT_GET install $PKG_LIST
185
186 if [ $? -ne 0 ]; then
187 echo "Failed to download the rootfs, aborting."
188 return 1
189 fi
190
191 mv "$INSTALL_ROOT" "$cache/rootfs"
192 echo "Download complete."
193
194 return 0
195 }
196
197 copy_altlinux()
198 {
199
200 # make a local copy of the minialtlinux
201 echo -n "Copying rootfs to $rootfs_path ..."
202 #cp -a $cache/rootfs-$arch $rootfs_path || return 1
203 # i prefer rsync (no reason really)
204 mkdir -p $rootfs_path
205 rsync -Ha $cache/rootfs/ $rootfs_path/
206 return 0
207 }
208
209 update_altlinux()
210 {
211 chroot $cache/rootfs apt-get update
212 chroot $cache/rootfs apt-get -y dist-upgrade
213 }
214
215 install_altlinux()
216 {
217 mkdir -p @LOCALSTATEDIR@/lock/subsys/
218 (
219 flock -x 9
220 if [ $? -ne 0 ]; then
221 echo "Cache repository is busy."
222 return 1
223 fi
224
225 echo "Checking cache download in $cache/rootfs ... "
226 if [ ! -e "$cache/rootfs" ]; then
227 download_altlinux
228 if [ $? -ne 0 ]; then
229 echo "Failed to download 'altlinux base'"
230 return 1
231 fi
232 else
233 echo "Cache found. Updating..."
234 update_altlinux
235 if [ $? -ne 0 ]; then
236 echo "Failed to update 'altlinux base', continuing with last known good cache"
237 else
238 echo "Update finished"
239 fi
240 fi
241
242 echo "Copy $cache/rootfs to $rootfs_path ... "
243 copy_altlinux
244 if [ $? -ne 0 ]; then
245 echo "Failed to copy rootfs"
246 return 1
247 fi
248 return 0
249 ) 9>@LOCALSTATEDIR@/lock/subsys/lxc-altlinux
250
251 return $?
252 }
253
254 copy_configuration()
255 {
256
257 mkdir -p $config_path
258 grep -q "^lxc.rootfs" $config_path/config 2>/dev/null || echo "lxc.rootfs = $rootfs_path" >> $config_path/config
259 cat <<EOF >> $config_path/config
260 lxc.utsname = $name
261 lxc.tty = 4
262 lxc.pts = 1024
263 lxc.mount = $config_path/fstab
264 lxc.cap.drop = sys_module mac_admin mac_override sys_time
265
266 # When using LXC with apparmor, uncomment the next line to run unconfined:
267 #lxc.aa_profile = unconfined
268
269 #networking
270 lxc.network.type = $lxc_network_type
271 lxc.network.flags = up
272 lxc.network.link = $lxc_network_link
273 lxc.network.name = veth0
274 lxc.network.mtu = 1500
275 EOF
276 if [ ! -z ${ipv4} ]; then
277 cat <<EOF >> $config_path/config
278 lxc.network.ipv4 = $ipv4
279 EOF
280 fi
281 if [ ! -z ${gw} ]; then
282 cat <<EOF >> $config_path/config
283 lxc.network.ipv4.gateway = $gw
284 EOF
285 fi
286 if [ ! -z ${ipv6} ]; then
287 cat <<EOF >> $config_path/config
288 lxc.network.ipv6 = $ipv6
289 EOF
290 fi
291 if [ ! -z ${gw6} ]; then
292 cat <<EOF >> $config_path/config
293 lxc.network.ipv6.gateway = $gw6
294 EOF
295 fi
296 cat <<EOF >> $config_path/config
297 #cgroups
298 lxc.cgroup.devices.deny = a
299 # /dev/null and zero
300 lxc.cgroup.devices.allow = c 1:3 rwm
301 lxc.cgroup.devices.allow = c 1:5 rwm
302 # consoles
303 lxc.cgroup.devices.allow = c 5:1 rwm
304 lxc.cgroup.devices.allow = c 5:0 rwm
305 lxc.cgroup.devices.allow = c 4:0 rwm
306 lxc.cgroup.devices.allow = c 4:1 rwm
307 # /dev/{,u}random
308 lxc.cgroup.devices.allow = c 1:9 rwm
309 lxc.cgroup.devices.allow = c 1:8 rwm
310 lxc.cgroup.devices.allow = c 136:* rwm
311 lxc.cgroup.devices.allow = c 5:2 rwm
312 # rtc
313 lxc.cgroup.devices.allow = c 10:135 rwm
314 EOF
315
316 cat <<EOF > $config_path/fstab
317 proc proc proc nodev,noexec,nosuid 0 0
318 sysfs sys sysfs defaults 0 0
319 EOF
320
321 if [ $? -ne 0 ]; then
322 echo "Failed to add configuration"
323 return 1
324 fi
325
326 return 0
327 }
328
329 clean()
330 {
331
332 if [ ! -e $cache ]; then
333 exit 0
334 fi
335
336 # lock, so we won't purge while someone is creating a repository
337 (
338 flock -x 9
339 if [ $? != 0 ]; then
340 echo "Cache repository is busy."
341 exit 1
342 fi
343
344 echo -n "Purging the download cache for ALTLinux-$release..."
345 rm --preserve-root --one-file-system -rf $cache && echo "Done." || exit 1
346 exit 0
347 ) 9>@LOCALSTATEDIR@/lock/subsys/lxc-altlinux
348 }
349
350 usage()
351 {
352 cat <<EOF
353 usage:
354 $1 -n|--name=<container_name>
355 [-p|--path=<path>] [-c|--clean] [-R|--release=<ALTLinux_release>]
356 [-4|--ipv4=<ipv4 address>] [-6|--ipv6=<ipv6 address>]
357 [-g|--gw=<gw address>] [-d|--dns=<dns address>]
358 [-P|--profile=<name of the profile>] [--rootfs=<path>]
359 [-A|--arch=<arch of the container>]
360 [-h|--help]
361 Mandatory args:
362 -n,--name container name, used to as an identifier for that container from now on
363 Optional args:
364 -p,--path path to where the container rootfs will be created, defaults to @LXCPATH@. The container config will go under @LXCPATH@ in that case
365 -c,--clean clean the cache
366 -R,--release ALTLinux release for the new container. if the host is ALTLinux, then it will defaultto the host's release.
367 -4,--ipv4 specify the ipv4 address to assign to the virtualized interface, eg. 192.168.1.123/24
368 -6,--ipv6 specify the ipv6 address to assign to the virtualized interface, eg. 2003:db8:1:0:214:1234:fe0b:3596/64
369 -g,--gw specify the default gw, eg. 192.168.1.1
370 -G,--gw6 specify the default gw, eg. 2003:db8:1:0:214:1234:fe0b:3596
371 -d,--dns specify the DNS server, eg. 192.168.1.2
372 -P,--profile Profile name is the file name in /etc/lxc/profiles contained packages name for install to cache.
373 -A,--arch NOT USED YET. Define what arch the container will be [i686,x86_64]
374 ---rootfs rootfs path
375 -h,--help print this help
376 EOF
377 return 0
378 }
379
380 options=$(getopt -o hp:n:P:cR:4:6:g:d: -l help,rootfs:,path:,name:,profile:,clean,release:,ipv4:,ipv6:,gw:,dns: -- "$@")
381 if [ $? -ne 0 ]; then
382 usage $(basename $0)
383 exit 1
384 fi
385 eval set -- "$options"
386
387 while true
388 do
389 case "$1" in
390 -h|--help) usage $0 && exit 0;;
391 -p|--path) path=$2; shift 2;;
392 --rootfs) rootfs_path=$2; shift 2;;
393 -n|--name) name=$2; shift 2;;
394 -P|--profile) profile=$2; shift 2;;
395 -c|--clean) clean=$2; shift 2;;
396 -R|--release) release=$2; shift 2;;
397 -4|--ipv4) ipv4=$2; shift 2;;
398 -6|--ipv6) ipv6=$2; shift 2;;
399 -g|--gw) gw=$2; shift 2;;
400 -d|--dns) dns=$2; shift 2;;
401 --) shift 1; break ;;
402 *) break ;;
403 esac
404 done
405
406 if [ ! -z "$clean" -a -z "$path" ]; then
407 clean || exit 1
408 exit 0
409 fi
410
411 type apt-get >/dev/null 2>&1
412 if [ $? -ne 0 ]; then
413 echo "'apt-get' command is missing"
414 exit 1
415 fi
416
417 if [ -z "$path" ]; then
418 path=$default_path
419 fi
420
421 if [ -z "$profile" ]; then
422 profile=$default_profile
423 fi
424
425 if [ -z "$release" ]; then
426 if [ "$is_altlinux" ]; then
427 release=$(cat /etc/altlinux-release |awk '/^ALT/ {print $3}')
428 else
429 echo "This is not a ALTLinux host and release missing, use -R|--release to specify release"
430 exit 1
431 fi
432 fi
433
434 if [ -z "$ipv4" -a -z "$ipv6" ]; then
435 BOOTPROTO="dhcp"
436 else
437 BOOTPROTO="static"
438 fi
439
440 if [ "$(id -u)" != "0" ]; then
441 echo "This script should be run as 'root'"
442 exit 1
443 fi
444
445 # check for 'lxc.rootfs' passed in through default config by lxc-create
446 if [ -z "$rootfs_path" ]; then
447 if grep -q '^lxc.rootfs' $path/config 2>/dev/null ; then
448 rootfs_path=$(awk -F= '/^lxc.rootfs =/{ print $2 }' $path/config)
449 else
450 rootfs_path=$path/rootfs
451 fi
452 fi
453
454 config_path=$default_path/$name
455 cache=$cache_base/$release/$profile
456
457 install_altlinux
458 if [ $? -ne 0 ]; then
459 echo "failed to install altlinux"
460 exit 1
461 fi
462
463 configure_altlinux
464 if [ $? -ne 0 ]; then
465 echo "failed to configure altlinux for a container"
466 exit 1
467 fi
468
469 copy_configuration
470 if [ $? -ne 0 ]; then
471 echo "failed write configuration file"
472 exit 1
473 fi
474
475 if [ ! -z $clean ]; then
476 clean || exit 1
477 exit 0
478 fi
479 echo "container rootfs and config created"
480 echo "network configured as $lxc_network_type in the $lxc_network_link"